USE SQLDayLite2015;
GO

-- A jak si zachowaj zapytania na widokach?
CREATE VIEW dbo.vProduct
AS
SELECT
	ID,
	Name,
	Price,
	ValidFrom,
	ValidTo
FROM dbo.Product


SELECT *
FROM dbo.Product
FOR SYSTEM_TIME AS OF '2015-11-21 11:13:31' -- <-- SELECT * FROM Product, data ValidFrom - najnowsza wersja
FOR SYSTEM_TIME AS OF '2015-11-20 23:02:15' -- <-- odejmij 1-2s odValidFrom dla SELECT * FROM dbo.product

-- a jak z widokiem?
SELECT *
FROM dbo.vProduct
--FOR SYSTEM_TIME AS OF '2015-11-20 23:02:16'
FOR SYSTEM_TIME AS OF '2015-11-21 11:13:31'


-- a jak damy FOR SYSTEM_TIME w widoku?
CREATE VIEW dbo.vProductLast
AS
SELECT
	ID,
	Name,
	Price,
	ValidFrom,
	ValidTo
FROM dbo.Product
FOR SYSTEM_TIME AS OF '9999-12-31 23:59:58' --< AS OF jest mniejsze od ValidTo, to odejmujemy 1s

SELECT *
FROM vProductLast

-- a jak np. w CTE?
WITH Dane AS (
SELECT
	ID,
	Name,
	Price,
	ValidFrom,
	ValidTo
FROM dbo.Product
FOR SYSTEM_TIME AS OF '2015-11-20 15:52:41'
)
SELECT * FROM Dane

-- a tak?
WITH Dane AS (
SELECT
	ID,
	Name,
	Price,
	ValidFrom,
	ValidTo
FROM dbo.Product
)
SELECT *
FROM Dane
FOR SYSTEM_TIME AS OF '2015-11-20 10:58:05'