USE SQLDayLite2015;
GO

DROP TABLE IF EXISTS dbo.Sterta;
DROP SCHEMA IF EXISTS hist;
GO

CREATE SCHEMA hist AUTHORIZATION dbo;
GO

CREATE TABLE dbo.Sterta (
	Id			INT				NULL,
	NazwaJakas	VARCHAR(200)	NULL,
	
	PERIOD FOR SYSTEM_TIME (WazneOd, WazneDo),

	WazneOd datetime2(0) GENERATED ALWAYS AS ROW START NOT NULL DEFAULT '1900-01-01',
	WazneDo datetime2(0) GENERATED ALWAYS AS ROW END NOT NULL DEFAULT '9999-12-31 23:59:59'
)
GO

















-- jak na razie dziaa, to sprbujmy doda obsug wersjonowania
ALTER TABLE dbo.Sterta
SET (
	SYSTEM_VERSIONING = ON (HISTORY_TABLE = hist.Sterta, DATA_CONSISTENCY_CHECK = ON)
)










-- Msg 13553, Level 16, State 1, Line 39
-- System versioned temporal table 'SQLDayLite2015.dbo.Sterta' must have primary key defined.