﻿USE master;
GO

-- hej, od wersji 2016 CTP 3.0 mozna tak!
DROP DATABASE IF EXISTS SQLDayLite2015;
GO

CREATE DATABASE SQLDayLite2015
ON PRIMARY (
	NAME		= N'SQLDayLite2015',
	FILENAME	= N'E:\DB\SQLDayLite2015.mdf',
	SIZE		= 5120MB,
	MAXSIZE		= UNLIMITED,
	FILEGROWTH	= 1024MB
) LOG ON (
	NAME		= N'SQLDayLite2015_log',
	FILENAME	= N'E:\DB\SQLDayLite2015_log.ldf',
	SIZE		= 1024MB,
	MAXSIZE		= 4096MB,
	FILEGROWTH	= 1024MB
);
GO

ALTER DATABASE SQLDayLite2015 SET RECOVERY SIMPLE;
GO

USE SQLDayLite2015;
GO


-- Przygotowanie tabel
CREATE TABLE dbo.Product (
	ProductID		INT IDENTITY CONSTRAINT PK_Product PRIMARY KEY,
	ProductName		VARCHAR(100) NOT NULL
)

CREATE TABLE dbo.Project (
	ProjectID		INT IDENTITY CONSTRAINT PK_Project PRIMARY KEY,
	ProjectName		VARCHAR(100) NOT NULL,
	ProductID		INT
		CONSTRAINT FK_Project_Product FOREIGN KEY 
			REFERENCES dbo.Product(ProductID)
)
GO

