USE SQLDayLite2015;
GO

-- Zasilimy teraz tabele/ danymi

-- na pocztek dodaj kilka produktw
INSERT INTO dbo.Product (Name, Price) VALUES
('Product 01', 10),
('Product 02', 20),
('Product 03', 30),
('Product 04', 40),
('Product 05', 50),
('Product 06', 60),
('Product 07', 70),
('Product 08', 80),
('Product 09', 90)

SELECT *
FROM dbo.Product
ORDER BY ID

SELECT *
FROM hist.Product
ORDER BY ID

-- fajnie, mamy 9 produktw, kady z nich ma t sam dat ValidFrom
-- dodajmy kilka nastpnych rekordw, z pewnymi przerwami

BEGIN TRANSACTION
INSERT INTO dbo.Product (Name, Price) VALUES
('Product 21', 210),
('Product 22', 220),
('Product 23', 230),
('Product 24', 240),
('Product 25', 250)

WAITFOR DELAY '00:00:05' -- 5 sekund

INSERT INTO dbo.Product (Name, Price) VALUES
('Product 31', 310),
('Product 32', 320),
('Product 33', 330),
('Product 34', 340),
('Product 35', 350)

COMMIT TRANSACTION

SELECT *
FROM dbo.Product
WHERE
	Name > 'Product 09'
ORDER BY ID

SELECT *
FROM hist.Product
ORDER BY ID

-- mimo, e dodawalimy rekordy z piciosekundow przerw,
-- to i tak wszystkie maj t sam dat ValidFrom - z rozpoczcia transakcji

-- to teraz modyfikacja danych: podnie dwukrotnie cen produktw od 01 do 09
UPDATE dbo.Product SET
	Price = Price * 2
WHERE
	Name BETWEEN 'Product 01' AND 'Product 09'
GO 5

SELECT *
FROM dbo.Product
WHERE
	Name BETWEEN 'Product 01' AND 'Product 09'
ORDER BY ID

SELECT *
FROM hist.Product
ORDER BY ID, ValidFrom

SELECT *
FROM dbo.Product
FOR SYSTEM_TIME AS OF '2015-11-21 11:44:29'
WHERE
	Name = 'Product 01'


-- a co si stanie przy kasowaniu?
DELETE dbo.Product
WHERE
	Name > 'Product 09'

SELECT *
FROM dbo.Product
ORDER BY ID

SELECT *
FROM hist.Product
ORDER BY ID






-- niespodzienki nie ma, rekordy s tylko w tabeli historycznej
-- z dat ValidTo zgodn z dat transakcji
