USE SQLDayLite2015;
GO

-- eby mie komplet informacji powinnimy odpyta 
-- zarwno tabel gwn jak i historyczn; ale nie musimy tego robi

SELECT DISTINCT ValidTo FROM hist.Product ORDER BY ValidTo 

-- Nowe elementy skadni SELECT

-- AS OF == wg stanu na @moment: ValidFrom <= @moment < ValidTo
-- uyj pierwszej wartoci z zapytania pitro wyej do AS OF
SELECT *
FROM dbo.Product
WHERE
	Name <= 'Product 09'

SELECT *
FROM hist.Product
WHERE
	Name <= 'Product 09'

SELECT *
FROM dbo.Product 
FOR SYSTEM_TIME AS OF '2015-11-19 20:41:40'
WHERE
	Name <= 'Product 09'


-- FROM @od TO @do  == rekordy aktywne midzy datami @od i @do:
-- ValidFrom < @do AND @od < ValidTo
-- ValidFrom < @do AND ValidTo > @od
-- @do > ValidFrom AND @od < ValidTo

SELECT *
FROM dbo.Product
FOR SYSTEM_TIME FROM '2015-11-19 20:41:40' TO '2015-11-19 20:43:09'
-- FOR SYSTEM_TIME FROM '2015-11-19 20:41:39' TO '2015-11-19 20:43:09' --< odejmij 1s od ValidFrom
-- inaczej == poka mi w jakie okresy zaapay si te daty

-- BETWEEN @od AND @do  == tak jak FROM .. TO, ale z uwzgldnieniem ValidFrom
-- ValidFrom <= @do AND @od < ValidTo
-- ValidFrom <= @do AND ValidTo > @od
-- @do >= ValidFrom AND @od < ValidTo
-- UWAGA: "normalne" BETWEEN uwzgldnia obie granice, czyli 
-- inaczej ni w zapytaniach Temporal Tables

SELECT *
FROM dbo.Product
--FOR SYSTEM_TIME BETWEEN '2015-11-19 20:41:40' AND '2015-11-19 20:43:09'
FOR SYSTEM_TIME BETWEEN '2015-11-19 20:41:40' AND '2015-11-19 21:37:23'
-- inaczej == poka mi w jakie okresy zaapay si te daty

-- CONTAINED IN (@od, @do) == okresy musz si zawiera midzy datami ValidFrom i ValidTo
-- ValidFrom <= @od AND @do >= ValidTo
-- ValidFrom <= @od AND ValidTo <= @do
-- @od >= ValidFrom AND @do <= ValidTo
SELECT *
FROM dbo.Product
FOR SYSTEM_TIME CONTAINED IN ('2015-11-19 20:41:40', '2015-11-19 21:37:23')
-- daty ValidFrom i ValidTo musz si zawiera midzy podanymi zakresami
-- inaczej == poka mi co byo wane dokadnie midzy tymi datami

-- ALL == po prostu poka mi wszystkie rekordy
SELECT *
FROM dbo.Product
FOR SYSTEM_TIME ALL
WHERE
	Name = 'Product 01'
ORDER BY
	ValidFrom